<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/metering_util_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/20/85  metering_util_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>Entry points in metering_util_:
<span id="L5" class="LineNr">  5 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>The metering_util_ subroutine contains several entry points useful for
<span id="L9" class="LineNr">  9 </span>collecting hardcore metering data.  In general, hardcore metering data
<span id="L10" class="LineNr"> 10 </span>elements can be categorized as samples, cumulative times, or cumulative
<span id="L11" class="LineNr"> 11 </span>counts <span class="textRainbow_lv0_p0">(</span>the latter two being cumulative since system initialization<span class="textRainbow_lv0_p0">)</span>.
<span id="L12" class="LineNr"> 12 </span>Samples are snapshots of variables that describe the state of some
<span id="L13" class="LineNr"> 13 </span>system object <span class="textRainbow_lv0_p0">(</span>e.g<span class="textRainbow_lv0_o0">,</span> number of processes eligible at this instant<span class="textRainbow_lv0_p0">)</span>.  An
<span id="L14" class="LineNr"> 14 </span>example of a cumulative count is the total number of read I/Os issued
<span id="L15" class="LineNr"> 15 </span>to a particular disk device since system initialization, while an
<span id="L16" class="LineNr"> 16 </span>example of a cumulative time is the total busy time of a particular
<span id="L17" class="LineNr"> 17 </span>disk device while processing read I/Os.  It is easy to compute average
<span id="L18" class="LineNr"> 18 </span>I/O time for a read to a particular device from these last two items.
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>If a given set of metering data is sampled periodically, then more
<span id="L22" class="LineNr"> 22 </span>interesting, time-varying data can be computed.  For example, the
<span id="L23" class="LineNr"> 23 </span>average I/O time for a read during a certain time interval can be
<span id="L24" class="LineNr"> 24 </span>computed.  That interval is the time between any two samples of the
<span id="L25" class="LineNr"> 25 </span>data; subtracting the earlier cumulative count of I/Os from the later
<span id="L26" class="LineNr"> 26 </span>count yields the incremental count <span class="textRainbow_lv0_p0">(</span>i.e.<span class="textRainbow_lv0_o0">,</span> the count of I/Os during the
<span id="L27" class="LineNr"> 27 </span>interval<span class="textRainbow_lv0_p0">)</span>.
<span id="L28" class="LineNr"> 28 </span>
<span id="L29" class="LineNr"> 29 </span>
<span id="L30" class="LineNr"> 30 </span>Multics metering commands are designed for interactive use, with the
<span id="L31" class="LineNr"> 31 </span>interval boundaries defined by the user in real time.  Typically,
<span id="L32" class="LineNr"> 32 </span>metering commands support the following control arguments:
<span id="L33" class="LineNr"> 33 </span>-report
<span id="L34" class="LineNr"> 34 </span>   prints a report of activity since the last interval boundary <span class="textRainbow_lv0_p0">(</span>or
<span id="L35" class="LineNr"> 35 </span>   since system initialization<span class="textRainbow_lv0_o0">,</span> if no boundary has been defined<span class="textRainbow_lv0_p0">)</span>.
<span id="L36" class="LineNr"> 36 </span>-reset
<span id="L37" class="LineNr"> 37 </span>   defines an interval boundary for this metering program; all further
<span id="L38" class="LineNr"> 38 </span>   invocations of this command display data reflecting activity since
<span id="L39" class="LineNr"> 39 </span>   this boundary.
<span id="L40" class="LineNr"> 40 </span>-report_reset
<span id="L41" class="LineNr"> 41 </span>   reports and then resets.
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>Under this scheme, each display of data, establishment of an interval
<span id="L45" class="LineNr"> 45 </span>boundary, etc., is done in a separate invocation of the same metering
<span id="L46" class="LineNr"> 46 </span>program.  This allows the user to establish an interval boundary,
<span id="L47" class="LineNr"> 47 </span>exercise the system in some fashion, and then print data describing the
<span id="L48" class="LineNr"> 48 </span>system performance while it was being exercised.  Additionally, a user
<span id="L49" class="LineNr"> 49 </span>can run any number of metering programs, each with independent interval
<span id="L50" class="LineNr"> 50 </span>boundaries.  These considerations imply that metering data collection
<span id="L51" class="LineNr"> 51 </span><span class="textRainbow_lv0_p0">(</span>which is sampling of hardcore data bases<span class="textRainbow_lv0_p0">)</span> should be global to the
<span id="L52" class="LineNr"> 52 </span>process <span class="textRainbow_lv0_p0">(</span>in order to exist through multiple invocations of the same
<span id="L53" class="LineNr"> 53 </span>metering command<span class="textRainbow_lv0_p0">)</span> and be distinguished among different metering
<span id="L54" class="LineNr"> 54 </span>programs.
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>To use this subroutine, sufficient access to copy all hardcore regions
<span id="L58" class="LineNr"> 58 </span>specified is required.  Access to the phcs_ gate is sufficient.  If all
<span id="L59" class="LineNr"> 59 </span>hardcore regions specified are defined in
<span id="L60" class="LineNr"> 60 </span>&gt;sl1&gt;ring_zero_meters_limits.ascii, then access to metering_gate_ is
<span id="L61" class="LineNr"> 61 </span>sufficient.
<span id="L62" class="LineNr"> 62 </span>
<span id="L63" class="LineNr"> 63 </span>
<span id="L64" class="LineNr"> 64 </span>:Entry:  define_regions:  02/20/85 metering_util_$define_regions
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>
<span id="L67" class="LineNr"> 67 </span>Function:  This entry is used to define a set of sections of hardcore
<span id="L68" class="LineNr"> 68 </span>data bases which are of interest to the invoker.  Upon return,
<span id="L69" class="LineNr"> 69 </span>sufficient static storage has been allocated to contain two copies of
<span id="L70" class="LineNr"> 70 </span>each hardcore region specified in the call; this storage has also been
<span id="L71" class="LineNr"> 71 </span>initialized to zero.
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>Syntax:
<span id="L75" class="LineNr"> 75 </span>declare code fixed bin <span class="textRainbow_lv0_p0">(</span>35<span class="textRainbow_lv0_p0">)</span>; declare unique_index fixed bin; declare
<span id="L76" class="LineNr"> 76 </span>     metering_util_$define_regions entry options <span class="textRainbow_lv0_p0">(</span>variable<span class="textRainbow_lv0_p0">)</span>;
<span id="L77" class="LineNr"> 77 </span>call metering_util_$define_regions <span class="textRainbow_lv0_p0">(</span>unique_index<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_o0">,</span>
<span id="L78" class="LineNr"> 78 </span>          hardcore_seg_1<span class="textRainbow_lv0_o0">,</span> begin_region_1<span class="textRainbow_lv0_o0">,</span> end_region_1<span class="textRainbow_lv0_o0">,</span> ...  <span class="textRainbow_lv0_o0">,</span> ...  <span class="textRainbow_lv0_o0">,</span>
<span id="L79" class="LineNr"> 79 </span>          ...  hardcore_seg_n<span class="textRainbow_lv0_o0">,</span> begin_region_n<span class="textRainbow_lv0_o0">,</span> end_region_n<span class="textRainbow_lv0_p0">)</span>;
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>
<span id="L82" class="LineNr"> 82 </span>Arguments:
<span id="L83" class="LineNr"> 83 </span>unique_index
<span id="L84" class="LineNr"> 84 </span>   is a unique identifier for the set of regions.  This identifier must
<span id="L85" class="LineNr"> 85 </span>   be used in calls to other metering_util_ entry points.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L86" class="LineNr"> 86 </span>code
<span id="L87" class="LineNr"> 87 </span>   is a standard status code.  The code error_table_$wrong_no_of_args
<span id="L88" class="LineNr"> 88 </span>   is returned if the number of arguments remaining is not modulo 3.
<span id="L89" class="LineNr"> 89 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>The remaining arguments must be in groups of three, as shown in the
<span id="L93" class="LineNr"> 93 </span>calling sequence above.  Each such group defines a hardcore region by
<span id="L94" class="LineNr"> 94 </span>specifying a hardcore segment and a contiguous region within the
<span id="L95" class="LineNr"> 95 </span>segment.  The arguments in each group, in order, are the following:
<span id="L96" class="LineNr"> 96 </span>hardcore_seg_i
<span id="L97" class="LineNr"> 97 </span>   identifies the ring 0 data base.  It may be of the form char <span class="textRainbow_lv0_p0">(</span>*<span class="textRainbow_lv0_p0">)</span>, in
<span id="L98" class="LineNr"> 98 </span>   which case it is assumed to be the name of a ring 0 segment; or of
<span id="L99" class="LineNr"> 99 </span>   the form ptr aligned, in which case it is assumed to be a pointer to
<span id="L100" class="LineNr">100 </span>   the segment.  In the latter case, only the segment number is
<span id="L101" class="LineNr">101 </span>   significant.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L102" class="LineNr">102 </span>
<span id="L103" class="LineNr">103 </span>
<span id="L104" class="LineNr">104 </span>begin_region_i
<span id="L105" class="LineNr">105 </span>   identifies the beginning of the region in the ring 0 data base.  It
<span id="L106" class="LineNr">106 </span>   may be of the form char <span class="textRainbow_lv0_p0">(</span>*<span class="textRainbow_lv0_p0">)</span>, in which case it is assumed to be the
<span id="L107" class="LineNr">107 </span>   name of an external symbol in hardcore_seg_i; or of the form fixed
<span id="L108" class="LineNr">108 </span>   bin, in which case it is assumed to be a word offset into
<span id="L109" class="LineNr">109 </span>   hardcore_seg_i.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L110" class="LineNr">110 </span>end_region_i
<span id="L111" class="LineNr">111 </span>   identifies the end of the region in the ring 0 data base.  It may be
<span id="L112" class="LineNr">112 </span>   of the form char <span class="textRainbow_lv0_p0">(</span>*<span class="textRainbow_lv0_p0">)</span>, in which case it is assumed to be the name of
<span id="L113" class="LineNr">113 </span>   an external symbol in hardcore_seg_i that refers to the next word
<span id="L114" class="LineNr">114 </span>   beyond the end of the region; or of the form fixed bin, in which
<span id="L115" class="LineNr">115 </span>   case it is assumed to be the length of the region in words.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>
<span id="L118" class="LineNr">118 </span>Notes:  Any errors encountered by this entry point are reported to the
<span id="L119" class="LineNr">119 </span>user by means of the sub_err_ subroutine.  Examples of such errors are
<span id="L120" class="LineNr">120 </span>invalid segment names or symbol names, or invalid region specification
<span id="L121" class="LineNr">121 </span><span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span> nonpositive length<span class="textRainbow_lv0_p0">)</span>.  Errors of this sort are always programming
<span id="L122" class="LineNr">122 </span>errors, and are not external circumstances from which the calling
<span id="L123" class="LineNr">123 </span>program can be expected to recover.
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>:Entry:  fill_buffers:  02/20/85 metering_util_$fill_buffers
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>Function:  This entry is used to copy the current contents of all
<span id="L130" class="LineNr">130 </span>regions defined for the specified unique identifier into the current
<span id="L131" class="LineNr">131 </span>buffers for that unique identifier, and to return pointers to the
<span id="L132" class="LineNr">132 </span>current and previous buffers for these regions.
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>Syntax:
<span id="L136" class="LineNr">136 </span>declare metering_util_$fill_buffers entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L137" class="LineNr">137 </span>     char<span class="textRainbow_lv1_p0">(</span>10<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> ptr<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L138" class="LineNr">138 </span>call metering_util_$fill_buffers <span class="textRainbow_lv0_p0">(</span>unique_index<span class="textRainbow_lv0_o0">,</span> meter_time<span class="textRainbow_lv0_o0">,</span>
<span id="L139" class="LineNr">139 </span>     formatted_time<span class="textRainbow_lv0_o0">,</span> current_ptrs<span class="textRainbow_lv0_o0">,</span> previous_ptrs<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>
<span id="L142" class="LineNr">142 </span>Arguments:
<span id="L143" class="LineNr">143 </span>unique_index
<span id="L144" class="LineNr">144 </span>   is the unique identifier returned by metering_util_$define_regions
<span id="L145" class="LineNr">145 </span>   <span class="textRainbow_lv0_p0">(</span>above<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L146" class="LineNr">146 </span>meter_time
<span id="L147" class="LineNr">147 </span>   is the total metering time in microseconds.  The total metering time
<span id="L148" class="LineNr">148 </span>   is defined as the time between the last call to metering_util_$reset
<span id="L149" class="LineNr">149 </span>   and this call.  If metering_util_$reset has not been called, the
<span id="L150" class="LineNr">150 </span>   total metering time is defined as the time between the last system
<span id="L151" class="LineNr">151 </span>   bootload and this call.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L152" class="LineNr">152 </span>
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>formatted_time
<span id="L155" class="LineNr">155 </span>   is the total metering time in a format suitable for printing.  This
<span id="L156" class="LineNr">156 </span>   format is
<span id="L157" class="LineNr">157 </span>      HHHH:MM:SS
<span id="L158" class="LineNr">158 </span>   where this represents the decomposition of total metering time into
<span id="L159" class="LineNr">159 </span>   hours <span class="textRainbow_lv0_p0">(</span>HH<span class="textRainbow_lv0_p0">)</span>, minutes <span class="textRainbow_lv0_p0">(</span>MM<span class="textRainbow_lv0_p0">)</span>, and seconds <span class="textRainbow_lv0_p0">(</span>SS<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L160" class="LineNr">160 </span>current_ptrs
<span id="L161" class="LineNr">161 </span>   is an array of pointers that, on return, contain pointers to the
<span id="L162" class="LineNr">162 </span>   current buffers for the hardcore regions defined in the call to
<span id="L163" class="LineNr">163 </span>   metering_util_$define_regions.  The number of elements in this array
<span id="L164" class="LineNr">164 </span>   must be equal to the number of hardcore regions defined in the call
<span id="L165" class="LineNr">165 </span>   to metering_util$define regions.  The elements of this array are
<span id="L166" class="LineNr">166 </span>   pointers to the current buffers for the corresponding hardcore
<span id="L167" class="LineNr">167 </span>   regions.  Specifically, current_ptrs <span class="textRainbow_lv0_p0">(</span>i<span class="textRainbow_lv0_p0">)</span> contains on return a
<span id="L168" class="LineNr">168 </span>   pointer to the current buffer for hardcore_seg_i <span class="textRainbow_lv0_p0">(</span>defined above<span class="textRainbow_lv0_p0">)</span>.
<span id="L169" class="LineNr">169 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>previous_ptrs
<span id="L173" class="LineNr">173 </span>   is an array of pointers which, on return, contain pointers to the
<span id="L174" class="LineNr">174 </span>   previous buffers for the hardcore regions defined in the call to
<span id="L175" class="LineNr">175 </span>   metering_util_$define_regions.  The number of elements in this array
<span id="L176" class="LineNr">176 </span>   must be equal to the number of hardcore regions defined in the call
<span id="L177" class="LineNr">177 </span>   to metering_util_$define regions.  The elements of this array are
<span id="L178" class="LineNr">178 </span>   pointers to the previous buffers for the corresponding hardcore
<span id="L179" class="LineNr">179 </span>   regions.  Specifically, previous_ptrs <span class="textRainbow_lv0_p0">(</span>i<span class="textRainbow_lv0_p0">)</span> contains on return a
<span id="L180" class="LineNr">180 </span>   pointer to the previous buffer for hardcore_seg_i <span class="textRainbow_lv0_p0">(</span>defined above<span class="textRainbow_lv0_p0">)</span>.
<span id="L181" class="LineNr">181 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L182" class="LineNr">182 </span>code
<span id="L183" class="LineNr">183 </span>   is a standard status code.  If either the array current_ptrs or the
<span id="L184" class="LineNr">184 </span>   array previous_ptrs does not have the proper number of elements <span class="textRainbow_lv0_p0">(</span>see
<span id="L185" class="LineNr">185 </span>   above<span class="textRainbow_lv0_p0">)</span>, the code error_table_$invalid_array_size is returned, and no
<span id="L186" class="LineNr">186 </span>   action is performed.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L187" class="LineNr">187 </span>
<span id="L188" class="LineNr">188 </span>
<span id="L189" class="LineNr">189 </span>:Entry:  reset:  02/20/85 metering_util_$reset
<span id="L190" class="LineNr">190 </span>
<span id="L191" class="LineNr">191 </span>
<span id="L192" class="LineNr">192 </span>Function:  This entry point is called to reset the metering interval to
<span id="L193" class="LineNr">193 </span>the time of this call.  This is done by copying the current buffers
<span id="L194" class="LineNr">194 </span>into the previous buffers for all regions defined for the unique index
<span id="L195" class="LineNr">195 </span>specified.
<span id="L196" class="LineNr">196 </span>
<span id="L197" class="LineNr">197 </span>
<span id="L198" class="LineNr">198 </span>Syntax:
<span id="L199" class="LineNr">199 </span>declare metering_util_$reset entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L200" class="LineNr">200 </span>call metering_util_$reset <span class="textRainbow_lv0_p0">(</span>unique_index<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>
<span id="L203" class="LineNr">203 </span>Arguments:
<span id="L204" class="LineNr">204 </span>unique_index
<span id="L205" class="LineNr">205 </span>   is as above.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L206" class="LineNr">206 </span>code
<span id="L207" class="LineNr">207 </span>   is as above.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
